#подключаем необходимые библиотеки
import Adafruit_DHT
import time

#раскомментируем строку с нужным нам датчиком, остальные закомментируем
#sensor = Adafruit_DHT.DHT11
sensor = Adafruit_DHT.DHT22
#sensor = Adafruit_DHT.AM2302

#подключаем вывод датчика к GPIO 4
sensor_pin = 4

#объявляем переменную для управления циклом while
running = True

#создаем новый файл формата.txt с заданным именем
file = open('sensor_readings.txt', 'w')
file.write('Дата и время, температура, влажность\n')

#бесконечный цикл
while running:
    try:
        #считываем значения влажности и температуры
        humidity, temperature = Adafruit_DHT.read_retry(sensor, sensor_pin)

        #раскомментируем следующую строку, если нужно перевести температуру в градусы Фаренгейта
        #temperature = temperature * 9/5.0 + 32

        #иногда при снятии показаний возникают ошибки, и тогда фиксируется нулевой результат
        #следующая строка обеспечивает сохранение только корректных показаний
        if humidity is not None and temperature is not None:
            #вывести значения температуры и влажности
            print('Температура = ' + str(temperature) + ', Влажность = ' + str(humidity))
            #записываем время, дату, температуру и влажность в файл .txt
            file.write(time.strftime('%H:%M:%S %d/%m/%Y') + ', ' +
                str(temperature) + ', '+ str(humidity) + '\n')
        else:
            print('Не удалось получить показания. Попробуйте еще раз!')
        #делаем паузу 10 секунд между снятиями показаний
        time.sleep(10)
    #если введено что-то с клавиатуры, останавливаем цикл и закрываем текстовый файл
    except KeyboardInterrupt:
        print ('Программа остановлена')
        running = False
        file.close()
