#подключаем необходимые библиотеки
from gpiozero import LED
from flask import Flask, render_template, request

#создаем объект Flask
app = Flask(__name__)

#создаем объект, который связан с релейным модулем
relay = LED(17)
#выключаем реле, при этом помним, что реле работает по инвертированной логике 
relay.on()
#фиксируем текущее состояние реле
relay_state = 'Реле выключено'

#отображаем главную веб-страницу
@app.route('/')
def main():
   global relay_state
   #записываем состояние реле в файл index.html и отображаем его пользователю
   return render_template('index.html', relay_state=relay_state)

#когда нажата кнопка включения / выключения, вызываем функцию control()
@app.route('/<action>')
def control(action):
   global relay_state
   #если значение 'action' из URL — on, включаем реле
   if action == 'on':
      #включаем реле (помним про инвертированную логику)
      relay.off()
      #сохраняем состояние реле
      relay_state = 'Реле включено'
   if action == 'off':
      relay.on()
      relay_state = 'Реле выключено'

   #записываем состояние реле в файл index.html и отображаем его пользователю
   return render_template('index.html', relay_state=relay_state)

#запускаем веб-сервер
if __name__ == '__main__':
   app.run(host='0.0.0.0', port=80, debug=True)
